# Service Control API

Provides admission control and telemetry reporting for services integrated with Service Infrastructure.

- [REST Resource: v3](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest#v3)
- [REST Resource: v2.services](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest#v2.services)
- [REST Resource: v1.services](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest#v1.services)

## Service: servicecontrol.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery documents:

- <https://servicecontrol.googleapis.com/$discovery/rest?version=v2>
- <https://servicecontrol.googleapis.com/$discovery/rest?version=v1>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://servicecontrol.googleapis.com`

## REST Resource: [v2.services](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/check` | `POST /v2/services/{serviceName}:check` This method provides admission control for services that are integrated with [Service Infrastructure](https://cloud.google.com/service-infrastructure). |
| `https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report` | `POST /v2/services/{serviceName}:report` This method provides telemetry reporting for services that are integrated with [Service Infrastructure](https://cloud.google.com/service-infrastructure). |

## REST Resource: [v1.services](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v1/services)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v1/services/allocateQuota` | `POST /v1/services/{serviceName}:allocateQuota` Attempts to allocate quota for the specified consumer. |
| `https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v1/services/check` | `POST /v1/services/{serviceName}:check` Checks whether an operation on a service should be allowed to proceed based on the configuration of the service and related policies. |
| `https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v1/services/report` | `POST /v1/services/{serviceName}:report` Reports operation results to Google Service Control, such as logs and metrics. |